/*
  shortkoi.c.  Produce a table of Short KOI.
  F. da Cruz, Columbia University, 1994.
*/
char *name[] = {
    "SPACE",
    "EXCLAMATION MARK",
    "QUOTATION MARK",
    "NUMBER SIGN",
    "DOLLAR SIGN",
    "PERCENT SIGN",
    "AMPERSAND",
    "APOSTROPHE",
    "LEFT PARENTHESIS",
    "RIGHT PARENTHESIS",
    "ASTERISK",
    "PLUS SIGN",
    "COMMA",
    "HYPHEN, MINUS SIGN",
    "PERIOD, FULL STOP",
    "SOLIDUS, SLASH",
    "DIGIT ZERO",
    "DIGIT ONE",
    "DIGIT TWO",
    "DIGIT THREE",
    "DIGIT FOUR",
    "DIGIT FIVE",
    "DIGIT SIX",
    "DIGIT SEVEN",
    "DIGIT EIGHT",
    "DIGIT NINE",
    "COLON",
    "SEMICOLON",
    "LESS-THAN SIGN, LEFT ANGLE BRACKET",
    "EQUALS SIGN",
    "GREATER-THAN SIGN, RIGHT ANGLE BRACKET",
    "QUESTION MARK",
    "COMMERCIAL AT SIGN",
    "CAPITAL ROMAN LETTER A",
    "CAPITAL ROMAN LETTER B",
    "CAPITAL ROMAN LETTER C",
    "CAPITAL ROMAN LETTER D",
    "CAPITAL ROMAN LETTER E",
    "CAPITAL ROMAN LETTER F",
    "CAPITAL ROMAN LETTER G",
    "CAPITAL ROMAN LETTER H",
    "CAPITAL ROMAN LETTER I",
    "CAPITAL ROMAN LETTER J",
    "CAPITAL ROMAN LETTER K",
    "CAPITAL ROMAN LETTER L",
    "CAPITAL ROMAN LETTER M",
    "CAPITAL ROMAN LETTER N",
    "CAPITAL ROMAN LETTER O",
    "CAPITAL ROMAN LETTER P",
    "CAPITAL ROMAN LETTER Q",
    "CAPITAL ROMAN LETTER R",
    "CAPITAL ROMAN LETTER S",
    "CAPITAL ROMAN LETTER T",
    "CAPITAL ROMAN LETTER U",
    "CAPITAL ROMAN LETTER V",
    "CAPITAL ROMAN LETTER W",
    "CAPITAL ROMAN LETTER X",
    "CAPITAL ROMAN LETTER Y",
    "CAPITAL ROMAN LETTER Z",
    "LEFT SQUARE BRACKET",
    "REVERSE SOLIDUS, BACKSLASH",
    "RIGHT SQUARE BRACKET",
    "CIRCUMFLEX ACCENT",
    "LOW LINE, UNDERLINE",
    "CAPITAL CYRILLIC LETTER YU",
    "CAPITAL CYRILLIC LETTER A",
    "CAPITAL CYRILLIC LETTER BE",
    "CAPITAL CYRILLIC LETTER TSE",
    "CAPITAL CYRILLIC LETTER DE",
    "CAPITAL CYRILLIC LETTER IE",
    "CAPITAL CYRILLIC LETTER EF",
    "CAPITAL CYRILLIC LETTER GHE",
    "CAPITAL CYRILLIC LETTER HA",
    "CAPITAL CYRILLIC LETTER I",
    "CAPITAL CYRILLIC LETTER SHORT I",
    "CAPITAL CYRILLIC LETTER KA",
    "CAPITAL CYRILLIC LETTER EL",
    "CAPITAL CYRILLIC LETTER EM",
    "CAPITAL CYRILLIC LETTER EN",
    "CAPITAL CYRILLIC LETTER O",
    "CAPITAL CYRILLIC LETTER PE",
    "CAPITAL CYRILLIC LETTER YA",
    "CAPITAL CYRILLIC LETTER ER",
    "CAPITAL CYRILLIC LETTER ES",
    "CAPITAL CYRILLIC LETTER TE",
    "CAPITAL CYRILLIC LETTER U",
    "CAPITAL CYRILLIC LETTER ZHE",
    "CAPITAL CYRILLIC LETTER VE",
    "CYRILLIC SOFT SIGN",
    "CAPITAL CYRILLIC LETTER YERI",
    "CAPITAL CYRILLIC LETTER ZE",
    "CAPITAL CYRILLIC LETTER SHA",
    "CAPITAL CYRILLIC LETTER E",
    "CAPITAL CYRILLIC LETTER SHCHA",
    "CAPITAL CYRILLIC LETTER CHE",
    "DELETE"
};


main() {
    int i, j;
    char c;

    printf("SHORT KOI (KOI-7)\n");
    printf("CHAR DEC COL/ROW OCT HEX  DESCRIPTION\n");
    for (i = 32; i < 128; i++) {
	j = i - 32;
	c = (i == 127) ? 32 : i;
	printf("(%c)  %3d  %02d/%02d  %3o  %2X  %s\n",
	       c, i, i/16, i%16, i, i, name[j]);
    }
}
